﻿using Syncfusion.UI.Xaml.Charts;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Collections.Specialized;
using System.ComponentModel;
using System.Diagnostics;
using System.Globalization;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Collections;

namespace Sample1
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }
    }

    public class TimeSpanAxisExt :TimeSpanAxis
    {
        protected override void CalculateVisibleRange(Size avalableSize)
        {
            base.CalculateVisibleRange(avalableSize);

            TimeSpan interval=new TimeSpan();
            if (VisibleRange.Start > 1)
            {
                TimeSpan ts1 = TimeSpan.FromMilliseconds(VisibleRange.Start);
                TimeSpan ts2 = TimeSpan.FromMilliseconds(VisibleRange.End);

                TimeSpan diff = ts2.Subtract(ts1);

                interval = new TimeSpan(diff.Ticks / 10);

                if (interval.Seconds == 0)
                    interval = new TimeSpan(0, 0, 1);
            }

            this.GetType().GetProperty("VisibleInterval", System.Reflection.BindingFlags.NonPublic |
                System.Reflection.BindingFlags.Instance).SetValue(this, interval.TotalMilliseconds);
        }
    }

    public class Model
    {
        public TimeSpan XValue { get; set; }
        public double YValue { get; set; }
    }

    public class ViewModel
    {
        public ViewModel()
        {
            GenerateData();           
        }

        public void GenerateData()
        {
            Data = new ObservableCollection<Model>();
            Random rd = new Random();
            TimeSpan timeSpan = new TimeSpan(12, 0, 0);
            for (int i = 0; i < 100; i++)
            {
               timeSpan= timeSpan.Add(new TimeSpan(0, 0, i));
                Data.Add(new Model()
                {
                    XValue = timeSpan,
                    YValue = rd.Next(0, 50)
                });
            }
        }

        private ObservableCollection<Model> data;

        public ObservableCollection<Model> Data
        {
            get { return data; }
            set { data = value;  }
        }

        
       
    }
    
}
